F2MC16LX

;*********************************************************************
;***	Dclarations
;*********************************************************************

	#INCLUDE "%METAI%\F562regs.asm"

;*********************************************************************
;*** 	RAM : Variables
;*********************************************************************
	SEGMENT byte at 0100-03FF 'Ram0'
	WORDS
DebRam:

Var100	DS.B	 3   ;100
d103d	DS.B	13   ;103-10F
CheckSum	DS.B	     ;110
d111d	DS.B	     ;111
ModeSync	DS.B	     ;112	1 si liaison synchrone, 0 si async

	DS.B	$5D
FinRam:		     ;170
;
	DS.B	$90  ;$170-$1FF
Buffer	DS.B	$200 ;$200-$3FF

;*********************************************************************
;*** 	ROM
;*********************************************************************

;*******************************
;*** Vecteurs d'interruption ***
;*******************************

	SEGMENT byte at FFFC00-FFFF53 'VectSoft'
	LONGS

Vecteur	MACRO	Adrs,Mode
	 TRIPLE	Adrs
	 BYTE	Mode
	MEND

;vv.b	CEQU	255
;
;	REPEAT		;De IntFF jusqu' ..
;	Vecteur	IntBug,0
;vv	CEQU	vv-1
;	UNTIL	42 eq vv	;.. Int43 inclue

	SEGMENT byte at FFFF54-FFFFFF 'VectHard'
	Vecteur	IntDel,$FF	;54 Int42 Delayed Int generator module
	Vecteur	IntBug,$FF	;58 Int41 Flash memory status
	Vecteur	IntBug,$FF	;5C Int40 Uart 0 send
	Vecteur	IntBug,$FF	;60 Int39 Uart 0 receive
	Vecteur	IntBug,$FF	;64 Int38 Uart 1 send
	Vecteur	IntBug,$FF	;68 Int37 Uart 1 receive
	Vecteur	IntBug,$FF	;6C Int36 Timebase timer
	Vecteur	IntBug,$FF	;70 Int35 Input capture channel 2/3
	Vecteur	IntBug,$FF	;74 Int34 16b free-run. timer clear
	Vecteur	IntBug,$FF	;78 Int33 Input capture channel 0/1
	Vecteur	IntBug,$FF	;7C Int32 16b reload timer 1 underflow
	Vecteur	IntBug,$FF	;80 Int31 16b free-run. timer overflow
	Vecteur	IntBug,$FF	;84 Int30 16b reload timer 0 underflow
	Vecteur	IntBug,$FF	;88 Int29 8b timer 0/1/2 counter borrow
	Vecteur	IntBug,$FF	;8C Int28 DTP Ext.int. channel 6/7
	Vecteur	IntBug,$FF	;90 Int27 DTP Ext.int. channel 4/5
	Vecteur	IntBug,$FF	;94 Int26 DTP Ext.int. channel 2/3
	Vecteur	IntBug,$FF	;98 Int25 DTP Ext.int. channel 0/1
	Vecteur	IntBug,$FF	;9C Int24 PPG timmer 5 counter borrow
	Vecteur	IntBug,$FF	;A0 Int23 Output compare 5 match
	Vecteur	IntBug,$FF	;A4 Int22 PPG timmer 4 counter borrow
	Vecteur	IntBug,$FF	;A8 Int21 Output compare 4 match
	Vecteur	IntBug,$FF	;AC Int20 PPG timmer 3 counter borrow
	Vecteur	IntBug,$FF	;B0 Int19 Output compare 3 match
	Vecteur	IntBug,$FF	;B4 Int18 PPG timmer 2 counter borrow
	Vecteur	IntBug,$FF	;B8 Int17 Output compare 2 match
	Vecteur	IntBug,$FF	;BC Int16 PPG timmer 1 counter borrow
	Vecteur	IntBug,$FF	;C0 Int15 Output compare 1 match
	Vecteur	IntBug,$FF	;C4 Int14 PPG timmer 0 counter borrow
	Vecteur	IntBug,$FF	;C8 Int13 Output compare 0 match
	Vecteur	IntBug,$FF	;CC Int12
	Vecteur	IntBug,$FF	;D0 Int11 AD conversion terminated
	Vecteur	IntBug,$FF	;D4 Int10 Exception processing
	Vecteur	$000100,$FF	;D8 Int9  Int9 instruction
	Vecteur	Reset,$00	;DC Int8  Reset + mode
	Vecteur	0,0	;E0 Int7
	Vecteur	0,0	;E4 Int6
	Vecteur	0,0	;E8 Int5
	Vecteur	0,0	;EC Int4
	Vecteur	0,0	;F0 Int3
	Vecteur	0,0	;F4 Int2
	Vecteur	0,0	;F8 Int1
	Vecteur	$FF0000,$FF	;FC Int0

;*******************************************
;***	Interruptions	***
;*******************************************
	SEGMENT	byte at FFFE38 'code'
IntDel:			; FFFE38
	clrb	IO:DIRR.0	; Clear Delayed Int. Request
	reti

IntBug:			; FFFE3C
	mov	io:LPMCR,#$09
	jmpp	Reset_P0_01

;*******************************************
;***	Programme	***
;*******************************************
	SEGMENT	byte at FFF800 'code'

;****************************************
;*** Tlchargement (reset avec P0.0 = 0)
Telechargement:
	mov	rp,#0	;Register bank Pointer
	mov	ilm,#0	;Interrupt Level Mask
	or	CCR,#mS	;S=1 -> Utilise SSP

;--- Init Stack
	mov	A,#SEG FinRam
	mov	SSB,A
	movw	A,#OFFSET FinRam
	movw	SP,A

;--- Init PLL
	mov	io:CKSCR,#$F8
	nop

;--- Init variables, $70 (112) octets en ram
	mov	A,#SEG DebRam
	mov	DTB,A
	movw	RW0,#OFFSET DebRam
	movw	RW1,#FinRam-DebRam

	mov	A,#0
BcleRazRam:
	dtb
	mov	@RW0,A
	incw	RW0
	dwbnz	RW1,BcleRazRam

;--- Init Flash et Port0
	mov	A,#mWE	;Autorise criture en Flash
	mov	io:FMCS,A

	mov	io:DDR0,#$00	;Port 0 en entre

;--- Init ACIA 0 !!!
	movb	A,io:PDR0.1	;Mode Synchrone ?
	bz	PasModeSync	;non, saute

	mov	ModeSync,#1	;Configure mode Synchrone
	mov	io:SMR0,#$B9
	mov	io:SCR0,#$13
	mov	io:SSR0,#$00
	jmp	BSLAttdCmde
PasModeSync:
	mov	ModeSync,#0	;Configure mode asynchrone
	mov	io:CDCR0,#$83
	mov	io:SMR0,#$01
	mov	io:SCR0,#$13
	mov	io:SSR0,#$00
BSLAttdCmde:
	call	WaitCarFromUart	;Attend 1 caractre ?

;*** Commande 18 : Test de communication
	cmp	A,#$18	;Commande = test comunication
	bnz	PasCmdeTstCom

	and	A,#$F0	;Plus facile que mov A,#$11 ???
	or	A,#$01
	call	SendCarToUart	;Envoie un caractre ?
	jmp	BSLAttdCmde

PasCmdeTstCom:
	movw	rw0,#Var100
	dtb
	mov	@rw0,A
	incw	rw0

	mov	CheckSum,A
	movw	rw2,#4
cFFF873c:
	call	WaitCarFromUart
	mov	@rw0,A
	incw	rw0
	add	CheckSum,A
	dwbnz	rw2,cFFF873c

	mov	A,Var100
	mov	r0,A
	and	A,#$40
	bz	cFFF892c

	movw	rw0,#$190
	movw	rw1,#$0
	jmpp	@rl0
	nop	;**Ajouts pour provoquer adrs identiques  original

cFFF892c:
	mov	A,r0
	and	A,#$F8
	movw	rw0,#$FB39
	movw	rw2,#$4
cFFF89Bc:
	cmp	A,PCB:@rw0
	bnz	cFFF8A7c
	incw	rw0
	movw	rw1,PCB:@rw0
	jmp	@rw1
cFFF8A7c:
	incw	rw0
	incw	rw0
	incw	rw0
	dwbnz	rw2,cFFF89Bc
dF8B0d
	mov	A,Var100
	and	A,#$F0
	or	A,#$2
	call	SendCarToUart
	jmp	BSLAttdCmde
dF8BDd:
	mov	A,Var100
	and	A,#$F0
	or	A,#$4
	call	SendCarToUart
	jmp	BSLAttdCmde
dF8CAd:
	mov	A,Var100
	and	A,#$F0
	or	A,#$1
	call	SendCarToUart
	jmp	BSLAttdCmde

Cmde_00:	;F8D7
	call	dFADFd
	movw	rw2,A
	movw	rw1,A
	mov	A,#$0
	mov	ADB,A
	call	dFAEFd
	movw	rw0,A
cFFF8E4c:
	call	WaitCarFromUart
	mov	ADB:@rw2,A	;ADB inutile !!!
	incw	rw2
	add	CheckSum,A
	dwbnz	rw0,cFFF8E4c
	call	WaitCarFromUart
	cmp	A,$110
	bnz	cFFF8FFc
	jmp	dF8CAd
cFFF8FFc:
	jmp	dF8B0d

Cmde_38: ;F902
	call	WaitCarFromUart
	cmp	A,$110
	bz	cFFF90Ec
	jmp	dF8B0d
cFFF90Ec:
	mov	A,#$FE
	mov	ADB,A
	movw	A,#$AA
	movw	ADB:$AAAA,A
	movw	A,#$55
	movw	ADB:$5554,A
	movw	A,#$80
	movw	ADB:$AAAA,A
	movw	A,#$AA
	movw	ADB:$AAAA,A
	movw	A,#$55
	movw	ADB:$5554,A
	call	dFADFd
	movl	rl3,A
	call	dFAF4d
	movl	A,rl3
	movw	rw6,A
	movw	A,#$30
	movw	ADB:@rw6+#0,A	;ADB Inutile !
	mov	A,#$30
	call	dFB0Bd
	cmp	A,#$0
	bz	cFFF955c
	call	dFAC5d
	jmp	dF8BDd
cFFF955c:
	call	dFAC5d
	jmp	dF8CAd

Cmde_08: ;F95B
	call	dFAEFd
	movw	rw0,A
	lsrw	a
	movw	rw1,#$0
	addcw	A,rw1
	movw	rw3,A
	movw	rw1,#$500
cFFF969c:
	call	WaitCarFromUart
	mov	DTB:@rw1,A	;DTB Inutile !
	incw	rw1
	add	CheckSum,A
	dwbnz	rw0,cFFF969c
	mov	DTB:@rw1,#$FF	;DTB Inutile !
	call	WaitCarFromUart
	cmp	A,$110
	bz	cFFF988c
	jmp	dF8B0d
cFFF988c:
	movw	rw1,#$500
	call	dFADFd
	movl	rl3,A
cFFF990c:
	mov	A,#$FE
	mov	ADB,A
	movw	A,#$AA
	movw	ADB:$AAAA,A
	movw	A,#$55
	movw	ADB:$5554,A
	movw	A,#$A0
	movw	ADB:$AAAA,A
	call	dFAF4d
	movw	A,DTB:@rw1	;DTB INUTILE !
	movw	ADB:@rw6+#0,A	;ADB inutile !
	mov	A,#0
	call	dFB0Bd
	cmp	A,#$0
	bnz	cFFF9CCc
	incw	rw1
	incw	rw1
	incl	rl3
	incl	rl3
	dwbnz	rw3,cFFF990c
	call	dFAC5d
	jmp	dF8CAd
cFFF9CCc:
	call	dFAC5d
	jmp	dF8BDd

Cmde_28: ;F9D2
	call	WaitCarFromUart
	cmp	A,$110
	bz	cFFF9DEc
	jmp	dF8B0d
cFFF9DEc:
	mov	A,#$21
	call	SendCarToUart
	call	dFADFd
	movl	rl3,A
	call	dFAEFd
	movw	rw3,A
	mov	CheckSum,#$0
cFFF9F1c:
	call	dFAF4d
	movw	A,ADB:@rw6+#$0	;ADB INUTILE !
	movw	rw0,A
	add	CheckSum,A
	call	dFA9Bd
	decw	rw3
	bz	cFFFA16c
	movw	A,rw0
	mov	r0,#$8
	lsrw	A,r0
	add	CheckSum,A
	call	dFA9Bd
	incl	rl3
	incl	rl3
	dwbnz	rw3,cFFF9F1c
cFFFA16c:
	call	dFAC5d
	mov	A,CheckSum
	call	SendCarToUart
	jmp	BSLAttdCmde

;*** Envoi le caractre A via UART
SendCarToUart:
	mov	r0,A
	mov	A,ModeSync
	bz	SendAsync

;--- Mode synchrone
	mov	A,io:SSR0
	and	A,#$10
	bz	cFFFA30c
	mov	A,io:SDR0
cFFFA30c:
	mov	A,r0
	mov	io:SDR0,A
cFFFA33c:
	mov	A,io:SSR0
	and	A,#$10
	bz	cFFFA33c
	mov	A,io:SDR0
	ret

;--- Mode asynchrone
SendAsync:
	mov	A,io:SSR0
	and	A,#$8
	bz	SendAsync

	mov	A,r0
	mov	io:SDR0,A
	ret

;*** Attente 1 caractre via UART 0, retourn dans A
WaitCarFromUart:
	mov	A,ModeSync
	bz	WaitAsync

	;--- Mode synchrone
	mov	A,io:SSR0
	and	A,#mORE
	bz	cFFFA55c

	mov	A,#$13
	mov	io:SCR0,A
@cFFFA55c:
	mov	A,io:SSR0
	and	A,#mTDRE
	bz	cFFFA55c

	mov	A,#$0
	mov	io:SDR0,A

AttdCarRecu:
	mov	A,io:SSR0
	and	A,#mRDRF
	bz	AttdCarRecu

	mov	A,io:SDR0	;Lit car reu
	ret		;et retour

	;--- Mode asynchrone
WaitAsync:
	mov	A,io:SSR0	;Attend RDRF  1
	and	A,#mRDRF
	bz	WaitAsync

	mov	A,io:SDR0	;Lit car reu
	ret		;et retour

;***
cFFFA71c:
	mov	r0,A
	mov	A,ModeSync
	bz	cFFFA7Ec

	mov	A,d111d
	and	A,#$1
	bnz	cFFFA8Fc
cFFFA7Ec:
	mov	A,io:SSR0
	and	A,#$8
	bz	cFFFA9Ac

	mov	A,r0
	mov	io:SDR0,A
	mov	A,#$1
	mov	d111d,A
	jmp	cFFFA9Ac
cFFFA8Fc:
	mov	A,io:SSR0
	and	A,#$10
	bz	cFFFA9Ac
	mov	A,io:SDR0
	mov	A,r0
	mov	io:SDR0,A
cFFFA9Ac:
	ret

;---
dFA9Bd:
	mov	r0,A
	mov	A,ModeSync
	bz	cFFFAA8c

	mov	A,d111d
	and	A,#$1
	bnz	cFFFAB9c

cFFFAA8c:	mov	A,io:SSR0
	and	A,#$8
	bz	cFFFAA8c

	mov	A,r0
	mov	io:SDR0,A
	mov	A,#$1
	mov	d111d,A
	jmp	dFAC4d
cFFFAB9c:
	mov	A,io:SSR0
	and	A,#$10
	bz	cFFFAB9c

	mov	A,io:SDR0
	mov	A,r0
	mov	io:SDR0,A
dFAC4d
	ret
dFAC5d
	mov	A,ModeSync
	bz	cFFFAD9c

	mov	A,d111d
	and	A,#$1
	bz	cFFFADEc
cFFFAD1c:
	mov	A,io:SSR0
	and	A,#$10
	bz	cFFFAD1c

	mov	A,io:SDR0
cFFFAD9c:
	mov	A,#$0
	mov	d111d,A
cFFFADEc:
	ret
dFADFd
	movl	A,$100
	and	A,#$7
	or	A,#$F8
	swap
	swapw
	swap
	mov	r0,#$8
	lsrl	A,r0
	ret
dFAEFd
	movw	A,d103d
	swap
	ret
dFAF4d
	mov	A,r6
	cmp	A,#$FF
	bnz	cFFFB04c

	mov	A,#$FE
	mov	ADB,A
	mov	A,#$28
	mov	io:FMCS,A
	jmp	dFB0Ad
cFFFB04c:
	mov	ADB,A
	mov	A,#$20
	mov	io:FMCS,A
dFB0Ad:
	ret
dFB0Bd
	mov	r0,A
	movw	A,ADB:@rw6+#$0	;ADB INUTILE !
	andw	A,#$40
	movw	rw0,A
cFFFB13c:
	mov	A,r0
	call	cFFFA71c
	movw	A,ADB:@rw6+#$0	;ADB INUTILE !
	movw	rw2,A
	andw	A,#$40
	cmpw	A,rw0
	bz	cFFFB36c

	movw	rw0,A
	movw	A,rw2
	andw	A,#$20
	bz	cFFFB13c

	movw	A,ADB:@rw6+#$0	;ADB INUTILE !
	andw	A,#$40
	cmpw	A,rw0
	bz	cFFFB36c

	mov	A,#$1
	ret
cFFFB36c:
	mov	A,#$0
	ret

CodeCmde	MACRO	Code,Adresse
	BYTE	Code
	WORD	OFFSET Adresse
	MEND
TabCmdes:
	CodeCmde	$00,Cmde_00	;F8D7
	CodeCmde	$38,Cmde_38	;F902
	CodeCmde	$08,Cmde_08	;F95B
	CodeCmde	$28,Cmde_28	;F9D2


;*******************************************
;***	Initialisation	***
;*******************************************

	SEGMENT	byte at FFFB80-FFFF53 'Rom'
; Selon P0.1 et P0.0 fait :
; 00 : Mode Flash asynchrone
; 10 : Mode flash synchrone
; 01 : Excution en ram en $0200 (Buffer)
; 11 : Autotest ?

Reset:
	movb	A,io:PDR0.0	;Port0.0 = 0 ?
	bz	Reset_P0_x0	;oui, -> tlchargement

	movb	A,io:PDR0.1	;Port0.1 = 0?
	bz	Reset_P0_01	;oui, exec au dbut de Buffer $0200

	jmpp	Reset_P0_11	;non, autotest ?

;*****************
;*** P0 = xxxxxx01
Reset_P0_01:
	jmpp	Buffer

;*****************
;*** P0 = xxxxxxx0
Reset_P0_x0:
	jmpp	Telechargement

;*****************
;*** P0 = xxxxxx11 : Autotest ?
Reset_P0_11:

	;---
	mov	io:PDR2,#$00
	mov	io:DDR2,#$FF

	movw	A,#$380
	movw	sp,A
	movn	A,#$1
	mov	io:ICR13,A
	mov	io:ICR14,A
	mov	ilm,#$7
	and	ccr,#$0
	bra	cFFFBABc
cFFFBABc:
	;---
	mov	io:PDR2,#$01
	movw	A,io:PDR4
	mov	A,io:PDR6

	movn	A,#00
	movw	io:PDR4,A
	mov	io:PDR6,A

	movw	A,#$FFFF
	movw	io:DDR4,A	;et DDR5
	mov	io:DDR6,A
	mov	io:ADER,#$00

	mov	io:RDR0,#$FF
	mov	io:RDR0,#$00

	mov	io:RDR1,#$FF
	mov	io:RDR1,#$00

	notw	PDR4	;et PDR5
	not	PDR6
	notw	PDR4	;et PDR5
	not	PDR6

	movn	A,#0
	movw	io:DDR4,A
	mov	io:DDR6,A

	;---
	mov	io:PDR2,#$02
	mov	io:ADER,#$FF
	mov	io:ADCR1,#$0
	movw	io:ADCS0,#$8247
	wbtc	io:ADCS1.$7
	mov	io:PDR2,#$3

	movw	io:PRL0,#$0307
	mov	io:PPGC0,#$A1
	clrb	io:PPGC0.$3
	wbts	io:PPGC0.$3
	clrb	io:PPGC0.$3
	wbts	io:PPGC0.$3

	movw	io:PRL1,#$0307
	mov	io:PPGC1,#$A1
	clrb	io:PPGC1.$3
	wbts	io:PPGC1.$3
	clrb	io:PPGC1.$3
	wbts	io:PPGC1.$3

	movw	io:PRL2,#$0307
	mov	io:PPGC2,#$A1
	clrb	io:PPGC2.$3
	wbts	io:PPGC2.$3
	clrb	io:PPGC2.$3
	wbts	io:PPGC2.$3

	movw	io:PRL3,#$0307
	mov	io:PPGC3,#$A1
	clrb	io:PPGC3.$3
	wbts	io:PPGC3.$3
	clrb	io:PPGC3.$3
	wbts	io:PPGC3.$3

	movw	io:PRL4,#$0307
	mov	io:PPGC4,#$A1
	clrb	io:PPGC4.$3
	wbts	io:PPGC4.$3
	clrb	io:PPGC4.$3
	wbts	io:PPGC4.$3

	movw	io:PRL5,#$0307
	mov	io:PPGC5,#$A1
	clrb	io:PPGC5.$3
	wbts	io:PPGC5.$3
	clrb	io:PPGC5.$3
	wbts	io:PPGC5.$3

	mov	io:PCS01,#$93
	clrb	io:PPGC0.$3
	wbts	io:PPGC0.$3
	clrb	io:PPGC0.$3
	wbts	io:PPGC0.$3

	clrb	io:PPGC1.$3
	wbts	io:PPGC1.$3
	clrb	io:PPGC1.$3
	wbts	io:PPGC1.$3

	mov	io:PCS23,#$93
	clrb	io:PPGC2.$3
	wbts	io:PPGC2.$3
	clrb	io:PPGC2.$3
	wbts	io:PPGC2.$3

	clrb	io:PPGC3.$3
	wbts	io:PPGC3.$3
	clrb	io:PPGC3.$3
	wbts	io:PPGC3.$3

	mov	io:PCS45,#$93
	clrb	io:PPGC4.$3
	wbts	io:PPGC4.$3
	clrb	io:PPGC4.$3
	wbts	io:PPGC4.$3

	clrb	io:PPGC5.$3
	wbts	io:PPGC5.$3
	clrb	io:PPGC5.$3
	wbts	io:PPGC5.$3

	;---
	mov	io:PDR2,#$4
	mov	io:TCCS,#$20
	movw	io:OCCP0,#$FFFF
	movw	io:OCCP1,#$FFFF
	movw	io:OCCP2,#$FFFF
	movw	io:OCCP3,#$FFFF
	movw	io:OCCP4,#$FFFF
	movw	io:OCCP5,#$FFFF
	movw	io:OCS0,#$0C03
	movw	io:TCDT,#$FFFA
	movw	io:TCCS,#$0
cFFFCE2c:
	bbc	io:OCS0.$6,cFFFCE2c

	;---
	mov	io:PDR2,#$5
	mov	io:DDR4,#$FF
	mov	io:PDR4,#$0
	movw	rw0,#$A
cFFFCF2c:
	dwbnz	rw0,cFFFCF2c

	movw	io:ICS01,#$000F
	mov	io:PDR4,#$FF
	wbts	io:ICS01.$6
	movw	io:ICS01,#$000F
	mov	io:PDR4,#$0
	wbts	io:ICS01.$6

	movw	io:ICS23,#$000F
	mov	io:PDR4,#$FF
	wbts	io:ICS23.$6
	movw	io:ICS23,#$000F
	mov	io:PDR4,#$0
	wbts	io:ICS23.$6

	mov	io:DDR4,#$0

;----
	mov	io:PDR2,#$6
	mov	io:DDR1,#$7F
	mov	io:PDR1,#$0
	mov	io:DDR6,#$8
	mov	io:PDR6,#$0
	movw	rw0,#$14
cFFFD32c:
	dwbnz	rw0,cFFFD32c

	mov	io:EIRR,#$0
	mov	io:ELVR,#$55
	and	ccr,#$BF
	mov	io:ENIR,#$F
	mov	A,io:EIRR

	mov	io:ELVR,#$AA
	mov	io:ELVR,#$0
	mov	io:ENIR,#$0
	mov	io:EIRR,#$0
	mov	io:DDR1,#$0
	mov	io:DDR6,#$0
	mov	io:PDR2,#$7
	mov	io:ADER,#$0
	mov	io:CDCR0,#$FC
	mov	io:CDCR1,#$FC
	mov	io:SMR0,#$A3
	mov	io:SMR1,#$A3
	mov	io:SCR0,#$11
	mov	io:SCR1,#$11
	mov	io:SDR0,#$55
	mov	io:SODR1,#$55
	mov	A,io:SSR0
	mov	A,io:SSR1

	mov	io:PDR2,#$8
	movw	io:TMR0L,#$FFFF
	movw	io:TMR1L,#$FFFF
	movw	io:TMCR0L,#$F003
	movw	io:TMCR1L,#$F003

	mov	io:PDR2,#$09
	mov	io:DTCR0,#$4
	mov	io:DTCR1,#$47
	mov	io:DTCR2,#$A1
	mov	io:TMRR0,#$FF
	mov	io:TMRR1,#$FF
	mov	io:TMRR2,#$FF
	mov	io:SIGCR,#$1

	;---
	mov	io:PDR2,#$A
	movb	A,io:DIRR.$0
	mov	io:ICR15,#$A2
	mov	ilm,#$4
	mov	rp,#$5
	movw	A,#$380
	or	ccr,#$FF
	movw	sp,A
	setb	io:DIRR.$0
	nop
	bra	cFFFDBAc
cFFFDBAc:
	;---
	mov	io:PDR2,#$B
	mov	io:CKSCR,#$CC
	mov	io:TBTC,#$83
	wbts	io:TBTC.$3
	mov	io:TBTC,#$80
	wbts	io:TBTC.$3
	bra	cFFFDCEc
cFFFDCEc:
	;---
	mov	IO:PDR2,#$C
	mov	RP,#$0
	movn	A,#$0
	mov	DTB,A
	movw	RW0,#$40
	movw	A,#$100
	movw	A,#$5555
	filswi	DTB
	movw	RW0,#$36E
	movw	A,#$0182
	movw	A,#$5555
	filswi	DTB
	movw	RW0,#$40
	movw	A,#$AAAA
	movw	A,#$0100
	movswi	DTB,DTB

	movw	RW0,#$36E
	movw	A,#$AAAA
	movw	A,#$182
	movswi	DTB,DTB

	movw	RW0,#$40
	movw	A,#$0100
	movw	A,#$AAAA
	filswi	DTB
	movw	RW0,#$36E
	movw	A,#$182
	movw	A,#$AAAA
	filswi	DTB
	movw	RW0,#$40
	movw	A,#$5555
	movw	A,#$0100
	movswi	DTB,DTB
	movw	rw0,#$36E
	movw	A,#$5555
	movw	A,#$0182
	movswi	DTB,DTB

	;---
	mov	io:PDR2,#$0D
	mov	io:LPMCR,#$09
	jmpp	Reset_P0_01

	%ASSERT	* EQ $FFFE38

	end
