PIC16C50
;************************************************************************
;***	Demo		Version 1.0		***
;***	Module Principal	DemoPrin.asm		***
;***	P. Peyremorte	Octobre 2005		***
;************************************************************************

;10/10/05	V1.0	Premire version
;	NOTE	Ce programme n'a pas de sens, il ne sert qu' montrer
;		quelques fonctionnements de l'assembleur

;*******************************************
;***	Dfinitions	***
;*******************************************

	#INCLUDE	"Demo_Inc.asm"

;*** Constantes du module

;Dures en nombre de secondes
Duree01	EQU	1	;1 seconde
Duree10	EQU	10	;10 secondes
Duree60	EQU	60	;60 secondes

;*******************************************
;***	Variables	***
;*******************************************

	SEGMENT byte at 07-1F 'Files'

Indics	DS.B	;Indicateurs
	#DEFINE	Bouton  Indics,0	;Indique bouton appuy

Secondes	DS.W	;Dure sur 16 bits
SecondesH	EQU	Secondes+1

;*******************************************
;***	MACROS		***
;*******************************************

;*** Macro qui ajoute Ti (T1  T5)  une variable word

AjTemps	MACRO	Index,Variable
	movlw	LOW Duree&Index	;Ajoute Ti  DelaiAlarme
	addwf	Variable
	btfsc	Carry
	incf	Variable+1
	movlw	HIGH Duree&Index
	addwf	Variable+1
	MEND

;*******************************************
;***	Vecteur de reset	***
;*******************************************

	#IF	Pic EQ 54
	 SEGMENT byte at:01FF-0200 'Reset'	;Pour PIC16C54
	 %OUT	>>> ATTENTION : PIC 16C 54 <<<
	#ELSE
	 SEGMENT byte at:03FF-0400 'Reset'	;Pour PIC15C56
	 %OUT	>>> ATTENTION : PIC 16C 56 <<<
	#ENDIF

	goto	Reset

;*******************************************
;***	Programme principal	***
;*******************************************
	WORDS	;Adresses qui suivent ncessitent 2 octets

	SEGMENT byte at 000-1FE 'Page0'

;******************************************
;*** Initialisation ports / microcontrleur

Reset:
	movlw	%11000111
;		 11	;Non utiliss
;		   0	;RTCC pilot FQuartz/4
;		    0	;Comptage sur front montant
;		     0	;Prdiviseur assign  compteur
;	       	      111	;Prdivision par 256 => t=31.25ms
	option

	movlw	%00000011	;Configure PA
	tris	PortA

	clrf	Secondes	;Raz compteur de secondes
	clrf	SecondesH

;*********************
;*** Boucle principale
;*********************

BouclePrin:

	call	Bip_W	;Envoie un bip
	AjTemps	10,Secondes	;Ajoute 10 secondes au temps prvu

	btfsc	Capteur
	goto	CapteurInactif

@CapteurInactif:	;@ prfixe label local (entre 2 labels non locaux)

	;mettre ici boucle de dcomptage des secondes !

	call	Bip_W
	AjTemps	60,Secondes
	goto	BouclePrin

	END
;ne pas oublier le retourn chariot aprs le END !